package com.jeeplus.modules.sg.financial.project.util;
import com.jeeplus.common.utils.excel.ImportExcel;
import com.jeeplus.modules.sg.financial.project.entity.Project;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Row;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public  class ProExcelInfo {
    /**
     * 获取表格数据
     * @param importUtil
     * @return List<ErpAccount> 导入表格数据
     */
    public static List<Project> getProjectUtil(ImportUtil importUtil)  {
        int lastRow = importUtil.getLastDataRowNum();
        List<Project> list = new ArrayList<Project>();
        Project project = null;
        String costEstimate="";//费用估算
        for(int i=2; i<lastRow;i++){
            project = new Project();
            Row row = importUtil.getRow(i);
            String requireCode = (String) importUtil.getCellValue(row,5);
            if(StringUtils.isNotBlank(requireCode)) {
                project.setRequireName(requireCode);
                project.setType((String)importUtil.getCellValue(row,1));//类型
                project.setDemandUnit((String)importUtil.getCellValue(row,2));//需求提出单位
                project.setBdzName((String)importUtil.getCellValue(row,3));//变电站名称
                project.setLineName((String)importUtil.getCellValue(row,4));//线路名称
                project.setBulidClassificationResons((String)importUtil.getCellValue(row,6));//建设理由分类
                project.setBulbidResons((String)importUtil.getCellValue(row,7));//建设理由
                project.setAsicEquipment((String)importUtil.getCellValue(row,8));//设备基本状况
                project.setRunTheClass((String)importUtil.getCellValue(row,9));//运行班
                project.setProjectTeam((String)importUtil.getCellValue(row,10));//项目组
                costEstimate = (String) importUtil.getCellValue(row,11);
                project.setCostEstimate(Double.parseDouble(costEstimate));//费用估算
                project.setWhetherRheUpwind((String)importUtil.getCellValue(row,12));//是否迎风期度夏项目
                project.setSureDaDate((String)importUtil.getCellValue(row,13));//确定下达时间
                project.setTextRemark((String)importUtil.getCellValue(row,14));//备注
                project.setStatus(getStatus());
                list.add(project);
            }
        }
        return list;
    }

    public static String getStatus(){
        int machineId = 1;
        int hashCodeV = UUID.randomUUID().toString().hashCode();
        if (hashCodeV<0){
            hashCodeV=-hashCodeV;
        }
        return  (machineId+String.format("%015d",hashCodeV));
    }
}
